"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var t = __importStar(require("../../types"));
var typeString = 'UnionNode';
function unionNode(types) {
    var flatTypes = [];
    flattenTypes(types);
    function flattenTypes(nodes) {
        nodes.forEach(function (x) {
            if (isUnionNode(x)) {
                flattenTypes(x.types);
            }
            else {
                flatTypes.push(x);
            }
        });
    }
    return uniqueUnionTypes({
        type: typeString,
        types: flatTypes,
    });
}
exports.unionNode = unionNode;
function isUnionNode(node) {
    return node.type === typeString;
}
exports.isUnionNode = isUnionNode;
function uniqueUnionTypes(node) {
    return {
        type: node.type,
        types: lodash_1.default.uniqBy(node.types, function (x) {
            if (t.isLiteralNode(x)) {
                return x.value;
            }
            if (t.isInstanceOfNode(x)) {
                return x.type + "." + x.instance;
            }
            return x.type;
        }),
    };
}
exports.uniqueUnionTypes = uniqueUnionTypes;
//# sourceMappingURL=union.js.map